Index: channels/chan_iax2.c
===================================================================
--- channels/chan_iax2.c	(revision 381715)
+++ channels/chan_iax2.c	(working copy)
@@ -11601,13 +11601,15 @@
 			ast_string_field_set(iaxs[fr->callno], cid_name, connected.id.name.str);
 			iaxs[fr->callno]->calling_pres = ast_party_id_presentation(&connected.id);
 
-			if (iaxs[fr->callno]->owner) {
+			iax2_lock_owner(fr->callno);
+			if (iaxs[fr->callno] && iaxs[fr->callno]->owner) {
 				ast_set_callerid(iaxs[fr->callno]->owner,
 					S_COR(connected.id.number.valid, connected.id.number.str, ""),
 					S_COR(connected.id.name.valid, connected.id.name.str, ""),
 					NULL);
 				iaxs[fr->callno]->owner->caller.id.number.presentation = connected.id.number.presentation;
 				iaxs[fr->callno]->owner->caller.id.name.presentation = connected.id.name.presentation;
+				ast_channel_unlock(iaxs[fr->callno]->owner);
 			}
 		}
 		ast_party_connected_line_free(&connected);
